(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(['exports', 'react', './input/input', './input/textarea', './input/number', './input/autocomplete', './input/radiogroup', './input/checkbox', './input/select', './input/file', './input/paragraph', './input/header', './input/button', './input/hiddeninput'], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require('react'), require('./input/input'), require('./input/textarea'), require('./input/number'), require('./input/autocomplete'), require('./input/radiogroup'), require('./input/checkbox'), require('./input/select'), require('./input/file'), require('./input/paragraph'), require('./input/header'), require('./input/button'), require('./input/hiddeninput'));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react, global.input, global.textarea, global.number, global.autocomplete, global.radiogroup, global.checkbox, global.select, global.file, global.paragraph, global.header, global.button, global.hiddeninput);
        global.index = mod.exports;
    }
})(this, function (exports, _react, _input, _textarea, _number, _autocomplete, _radiogroup, _checkbox, _select, _file, _paragraph, _header, _button, _hiddeninput) {
    'use strict';

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    var _input2 = _interopRequireDefault(_input);

    var _textarea2 = _interopRequireDefault(_textarea);

    var _number2 = _interopRequireDefault(_number);

    var _autocomplete2 = _interopRequireDefault(_autocomplete);

    var _radiogroup2 = _interopRequireDefault(_radiogroup);

    var _checkbox2 = _interopRequireDefault(_checkbox);

    var _select2 = _interopRequireDefault(_select);

    var _file2 = _interopRequireDefault(_file);

    var _paragraph2 = _interopRequireDefault(_paragraph);

    var _header2 = _interopRequireDefault(_header);

    var _button2 = _interopRequireDefault(_button);

    var _hiddeninput2 = _interopRequireDefault(_hiddeninput);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var GenerateForm = function (_Component) {
        _inherits(GenerateForm, _Component);

        //initial state
        function GenerateForm(props) {
            _classCallCheck(this, GenerateForm);

            var _this = _possibleConstructorReturn(this, (GenerateForm.__proto__ || Object.getPrototypeOf(GenerateForm)).call(this));

            _this.state = {
                formHasFilesUpload: false,
                formJson: [] };
            _this.counter = 0;

            _this.getCounter = function () {
                return _this.counter++;
            };

            _this.result = {};

            _this.addToResult = function (name, value) {
                _this.result[name] = value;
            };

            if (props.formJson) props.formJson.map(function (item) {
                if (item.typeField == "fileUpload") _this.state.formHasFilesUpload = true;
            });
            return _this;
        }

        _createClass(GenerateForm, [{
            key: 'render',
            value: function render() {
                var _this2 = this;

                return _react2.default.createElement(
                    'div',
                    { className: 'field-input' },
                    _react2.default.createElement(
                        'form',
                        { action: '' },
                        _react2.default.createElement(
                            'fieldset',
                            null,
                            !this.props.formJson ? "" : _react2.default.createElement(
                                'div',
                                null,
                                this.props.formJson.map(function (item) {
                                    return _react2.default.createElement(
                                        'div',
                                        { key: _this2.getCounter() },
                                        function () {
                                            switch (item.typeField) {
                                                case "text":
                                                    return _react2.default.createElement(_input2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "textArea":
                                                    return _react2.default.createElement(_textarea2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "number":
                                                    return _react2.default.createElement(_number2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "autocomplete":
                                                    return _react2.default.createElement(_autocomplete2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "inputRadio":
                                                    return _react2.default.createElement(_radiogroup2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "inputCheckbox":
                                                    return _react2.default.createElement(_checkbox2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "select":
                                                    return _react2.default.createElement(_select2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "fileUpload":
                                                    return _react2.default.createElement(_file2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "paragraph":
                                                    return _react2.default.createElement(_paragraph2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "header":
                                                    return _react2.default.createElement(_header2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "button":
                                                    return _react2.default.createElement(_button2.default, { addToResult: _this2.addToResult, formJson: item });
                                                case "hiddenInput":
                                                    return _react2.default.createElement(_hiddeninput2.default, { addToResult: _this2.addToResult, formJson: item });
                                            }
                                        }()
                                    );
                                })
                            )
                        )
                    )
                );
            }
        }]);

        return GenerateForm;
    }(_react.Component);

    exports.default = GenerateForm;
});