(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports", "react"], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require("react"));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react);
        global.checkbox = mod.exports;
    }
})(this, function (exports, _react) {
    "use strict";

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Checkbox = function (_Component) {
        _inherits(Checkbox, _Component);

        //initial state
        function Checkbox(props) {
            _classCallCheck(this, Checkbox);

            var _this = _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this));

            _this.state = {
                text: "",
                id: "" };

            if (props.formJson.defaultSelected) {
                _this.state.text = true;
            } else {
                _this.state.text = false;
            }
            props.addToResult(props.formJson.name, _this.state.text);
            return _this;
        }

        //change input value


        _createClass(Checkbox, [{
            key: "changeValue",
            value: function changeValue(e) {
                var _this2 = this;

                console.log(e.target.checked);
                this.setState(_extends({}, this.state, {
                    text: e.target.checked
                }), function () {
                    _this2.props.addToResult(_this2.props.formJson.name, e.target.checked);
                });
            }
        }, {
            key: "render",
            value: function render() {
                var _this3 = this;

                return _react2.default.createElement(
                    "div",
                    { className: "form-group" },
                    _react2.default.createElement(
                        "label",
                        { className: "mainLabel inputLabel" },
                        _react2.default.createElement(
                            "span",
                            null,
                            this.props.formJson.label,
                            this.props.formJson.required ? _react2.default.createElement(
                                "span",
                                { className: "required" },
                                "*"
                            ) : ""
                        ),
                        _react2.default.createElement("input", { type: "checkbox",
                            required: this.props.formJson.required,
                            defaultChecked: this.props.formJson.defaultSelected,
                            name: this.props.formJson.name,
                            onChange: function onChange(e) {
                                return _this3.changeValue(e);
                            }
                        }),
                        this.props.formJson.sufix
                    ),
                    this.props.formJson.tipText ? _react2.default.createElement(
                        "p",
                        null,
                        this.props.formJson.tipText
                    ) : ""
                );
            }
        }]);

        return Checkbox;
    }(_react.Component);

    exports.default = Checkbox;
});