(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports", "react"], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require("react"));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react);
        global.number = mod.exports;
    }
})(this, function (exports, _react) {
    "use strict";

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Number = function (_Component) {
        _inherits(Number, _Component);

        //initial state
        function Number(props) {
            _classCallCheck(this, Number);

            var _this = _possibleConstructorReturn(this, (Number.__proto__ || Object.getPrototypeOf(Number)).call(this));

            _this.state = {
                text: "" };

            _this.state.text = props.formJson.value || "";
            props.addToResult(props.formJson.name, _this.state.text);
            return _this;
        }

        //change input value


        _createClass(Number, [{
            key: "changeValue",
            value: function changeValue(e) {
                var _this2 = this;

                this.setState({
                    text: e.target.value
                }, function () {
                    _this2.props.addToResult(_this2.props.formJson.name, _this2.state.text);
                });
            }
        }, {
            key: "render",
            value: function render() {
                var _this3 = this;

                return _react2.default.createElement(
                    "div",
                    { className: "form-group" },
                    _react2.default.createElement(
                        "label",
                        { className: "mainLabel inputLabel" },
                        _react2.default.createElement(
                            "span",
                            null,
                            this.props.formJson.label,
                            this.props.formJson.required ? _react2.default.createElement(
                                "span",
                                { className: "required" },
                                "*"
                            ) : ""
                        ),
                        _react2.default.createElement("input", { className: this.props.formJson.class || 'form-control',
                            required: this.props.formJson.required,
                            type: "number", onChange: function onChange(e) {
                                return _this3.changeValue(e);
                            },
                            value: this.state.text,
                            name: this.props.formJson.name,
                            placeholder: this.props.formJson.placeholder,
                            step: this.props.formJson.step,
                            min: this.props.formJson.min_value,
                            max: this.props.formJson.max_value }),
                        this.props.formJson.sufix
                    ),
                    this.props.formJson.tipText ? _react2.default.createElement(
                        "p",
                        null,
                        this.props.formJson.tipText
                    ) : ""
                );
            }
        }]);

        return Number;
    }(_react.Component);

    exports.default = Number;
});