(function (global, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports", "react"], factory);
    } else if (typeof exports !== "undefined") {
        factory(exports, require("react"));
    } else {
        var mod = {
            exports: {}
        };
        factory(mod.exports, global.react);
        global.select = mod.exports;
    }
})(this, function (exports, _react) {
    "use strict";

    Object.defineProperty(exports, "__esModule", {
        value: true
    });

    var _react2 = _interopRequireDefault(_react);

    function _interopRequireDefault(obj) {
        return obj && obj.__esModule ? obj : {
            default: obj
        };
    }

    var _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];

            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }

        return target;
    };

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    var _createClass = function () {
        function defineProperties(target, props) {
            for (var i = 0; i < props.length; i++) {
                var descriptor = props[i];
                descriptor.enumerable = descriptor.enumerable || false;
                descriptor.configurable = true;
                if ("value" in descriptor) descriptor.writable = true;
                Object.defineProperty(target, descriptor.key, descriptor);
            }
        }

        return function (Constructor, protoProps, staticProps) {
            if (protoProps) defineProperties(Constructor.prototype, protoProps);
            if (staticProps) defineProperties(Constructor, staticProps);
            return Constructor;
        };
    }();

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    var Select = function (_Component) {
        _inherits(Select, _Component);

        //initial state
        function Select(props) {
            _classCallCheck(this, Select);

            var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this));

            _this.state = {
                text: "",
                id: ""
            };
            _this.counter = 0;

            _this.getCounter = function () {
                return _this.counter++;
            };

            _this.state.text = props.formJson.value || "";
            props.addToResult(props.formJson.name, _this.state.text);
            return _this;
        }

        //change input value


        _createClass(Select, [{
            key: "changeValue",
            value: function changeValue(e) {
                var _this2 = this;

                this.setState(_extends({}, this.state, {
                    text: e.target.value
                }), function () {
                    _this2.props.addToResult(_this2.props.formJson.name, _this2.state.text);
                });
            }
        }, {
            key: "render",
            value: function render() {
                var _this3 = this;

                return _react2.default.createElement(
                    "div",
                    { className: "form-group" },
                    _react2.default.createElement(
                        "label",
                        { className: "mainLabel inputLabel" },
                        _react2.default.createElement(
                            "span",
                            null,
                            this.props.formJson.label,
                            this.props.formJson.required ? _react2.default.createElement(
                                "span",
                                { className: "required" },
                                "*"
                            ) : ""
                        ),
                        _react2.default.createElement(
                            "select",
                            {
                                required: this.props.formJson.required,
                                onChange: function onChange() {
                                    return _this3.changeValue();
                                }, className: this.props.formJson.class || 'form-control', name: this.props.formJson.name, defaultValue: this.state.text },
                            this.props.formJson.options.map(function (item) {
                                return _react2.default.createElement(
                                    "option",
                                    { key: _this3.getCounter(), value: item.value },
                                    item.label
                                );
                            })
                        )
                    ),
                    this.props.formJson.tipText ? _react2.default.createElement(
                        "p",
                        null,
                        this.props.formJson.tipText
                    ) : ""
                );
            }
        }]);

        return Select;
    }(_react.Component);

    exports.default = Select;
});